#!/bin/sh

usage() {
    echo -e -n "\n"
    echo "Usage: migrateProcessAppGlobalData.sh [options...] <package name>" 
    echo -e -n "\n"
    echo "Options:"
    echo "    -?, -help                             print this message"
    echo "    -h <host>, -host <host>               host of the process server where to deploy the package"
    echo "    -t <port>, -port <port>               port of the process server where to deploy the package"
    echo "    -u <username>, -username <username>   user name of the process server administrator"
    echo "    -p <password>, -password <password>   user password (unencrypted)"
    echo "    -profileName <name>                   profile name"
    echo "    -nodeName <name>                      node name in an ND Environment"
    echo "    -serverName <name>                    server name in an ND Environment"
    echo -e -n "\n"
    exit $1
}

if [  "$1" = "" -o "$1" = "-help" -o "$1" = "-?" ]; then
   usage 1
fi

TOOL_DIR=`dirname ${0}`

PARAMETER=

until [ "$#" = "0" ]
do
  PARAMETER="$PARAMETER $1"
  shift;
done

PARAMETER="$PARAMETER GlobalAssetMigrated"
eval "$TOOL_DIR/_internalInstallPackage.sh $PARAMETER"

if [ "$?" != "0" ]; then
    echo "Migrating global data for package failed ..."
      exit 1
fi

echo "Migrating global data for package is successful."
